#include<math.h>
#include"player.h"
#include"main.h"

PLAYER::PLAYER(){
	x=160;
	y=0;
	power=2;
	bd=0;
	pd=0;
	sp=0;
	md=0;
	sm=0;
	lives=3;
	score=0;
	dead=0;
	inv=0;
	img=(RLE_SPRITE*)rle[HULL0].dat;
}



PLAYER::~PLAYER(){
}



bool PLAYER::update(list<BULLET> *bullets,list<ENEMY> *enemies,list<ITEM> *items){
	int h=(power-1)/4;

	img=(RLE_SPRITE*)rle[HULL0+h].dat;
	int hw=img->w;
	int hh=img->h;

	for(list<BULLET>::iterator i=bullets->begin();i!=bullets->end();){
		if(!i->enemy){
			i++;
			continue;
		}
		if(i->x>x+hw/2 || i->y-i->h/2>y+hh/2 || i->x+i->w<x-hw/2 || i->y+i->h/2<y-hh/2)
			i++;
		else{
			i=bullets->erase(i);
			if(!inv){
				if(power>1)
					power--;
				else{
					power=0;
					return 0;
				}
			}
		}
	}

	for(list<ENEMY>::iterator i=enemies->begin();i!=enemies->end();){
		if(i->x>x+hw || i->y-i->h/2>y+hh/2 || i->x+i->w<x || i->y+i->h/2<y-hh/2)
			i++;
		else{
			i=enemies->erase(i);
			if(!inv){
				if(power>1)
					power--;
				else{
					power=0;
					return 0;
				}
			}
		}
	}

	for(list<ITEM>::iterator i=items->begin();i!=items->end();){
		if(i->x>x+hw/2 || i->y-i->h/2>y+hh/2 || i->x+i->w<x-hw/2 || i->y+i->h/2<y-hh/2)
			i++;
		else{
			if(i->type==0)
				sm+=sm<99;
			if(i->type==1)
				if(power<16)
					power++;
				else
					sp+=sp<99;
			i=items->erase(i);
		}
	}

	if(key[KEY_UP])
		y-=2;
	if(key[KEY_DOWN])
		y+=2;
	if(key[KEY_LEFT])
		x-=2;
	if(key[KEY_RIGHT])
		x+=2;

	if(h<3 && sp){
		sp=0;
		float a=0;
		for(int i=0;i<16;i++){
			a+=M_PI/8;
			bullets->push_back(BULLET(x,y,cos(a)*3,sin(a)*3,2,0));
		}
	}

	if(!(key_shifts&KB_CTRL_FLAG) && bd>3)	bd=3;
	if(bd)	bd--;
	if(key_shifts&KB_CTRL_FLAG && !bd){
		bullets->push_back(BULLET((float)x+hw/2,y,4,0,0,0));
		if(h>0)
			bullets->push_back(BULLET((float)x+hw/2,y+4,4,0,0,0));
		if(h>1)
			bullets->push_back(BULLET((float)x+hw/2,y+4,3,1,0,0));
		if(h>2)
			bullets->push_back(BULLET((float)x+hw/2,y,3,-1,0,0));
		bd=10;

		play_sample((SAMPLE*)rle[BULLETSHOT].dat, 255, 127, 800+rand()%200, 0);
	}

	if(md)	md--;
	if(key_shifts&KB_ALT_FLAG && !md && !berzerk){
		int m=-1;
		if(sm)	m=0;
		if(h>0 && sm>1)	m=1;
		if(h>1 && sm>2)	m=2;
		if(h>2 && sm>4)	m=3;
		if(m==0){
			bullets->push_back(BULLET((float)x+hw/2,y,3,0,1,0));
			sm--;
		}
		if(m==1){
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(-.2)*3,sin(-.2)*3,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(.2)*3,sin(.2)*3,1,0));
			sm-=2;
		}
		if(m==2){
			bullets->push_back(BULLET((float)x+hw/2,y,3,0,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(-.3)*3,sin(-.3)*3,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(.3)*3,sin(.3)*3,1,0));
			sm-=3;
		}
		if(m==3){
			bullets->push_back(BULLET((float)x+hw/2,y,3,0,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(-.2)*3,sin(-.2)*3,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(.2)*3,sin(.2)*3,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(-.4)*3,sin(-.4)*3,1,0));
			bullets->push_back(BULLET((float)x+hw/2,y+4,cos(.4)*3,sin(.4)*3,1,0));
			sm-=5;
		}
		md=30;
	}

	if(pd)	pd--;
	if(key[KEY_X] && !pd && sp && !berzerk){
		bullets->push_back(BULLET(x,y+4,3,0,3,0));
		pd=60;
		sp--;
	}

	if(berzerk){
		berzerk--;
		if(!berzerk)
			set_color(1,&(RGB){0,252,168,0});
	}
	if(key[KEY_Z] && !berzerk && sp>9){
		sp-=10;
		berzerk=300;
		set_color(1,&(RGB){252,168,0,0});
	}

	x=x<hw/2?hw/2:x;
	x=x+hw/2>320?320-hw/2:x;
	y=y<-180?-180:y;
	y=y>180?180:y;
	yoff-=(y+yoff-240/2)/25;
	if(yoff<30)yoff=30;
	if(yoff>210)yoff=210;

	return 1;
}



void PLAYER::draw(BITMAP *bmp){
	draw_rle_sprite(bmp, img, x-img->w/2, y+(int)yoff-img->h/2);
}
